# -*- coding: utf-8 -*-

import re
import subprocess
from bsddb.dbtables import Cond


#abbTweets = open("tweets_with_filtered_abb.txt").read().split("\n")
#abbPosFile = open("specific_abb_tut_pos.abbs").read().split("\n")
#abbPosFile = open("specific_abb_paisa_3.0GB_pos.abb").read().split("\n")
abbPosFile = open("specific_abb_paisa_full_lc_9.0GB_pos.abb").read().split("\n")

abbListFile = open("specific_abb_full_ls.abbs").read().split("\n")
abbsCondFile = open("../resources/abbsWithConditions.txt").read().split("\n")

abbDict = {entry.split("\t")[0]:entry.split("\t")[1] for entry in abbListFile}
abbsCondDict = {entry.split("\t")[1]:entry.split("\t")[0] for entry in abbsCondFile}

### Set booleans
debug = False
fileWrite  = True 
isCompareMode = True
isCreateSummary = True
isShowChangesOnly = False
### Set booleans

countDistinctAbb = 0
countMatch = 0

inputFileName = "tweets_with_filtered_abb.txt.cleantweets"
inputFileName = "twita_tweets201202_01.txt.cleantweets"
#inputFileName = "exampleTweets.txt.cleantweets"
inputFileSum = inputFileName + ".results"
if isCompareMode:
    if isShowChangesOnly:
        outputFile = inputFileName + "_compareChanged.normtweets"
    else:
        outputFile = inputFileName + "_compare.normtweets"
else:
    outputFile = inputFileName + ".normtweets"

abbTweets = open(inputFileName).read().split("\n")
abbTweetsUnchanged = abbTweets
normed_abbTweets = open(outputFile, "w")
normed_abbTweets_Results = open(inputFileSum, "w")

####### TreeTagger must ignore @ and # Twitter Tokens
tempTweetList = []
for tweet in abbTweets:
    wordList = tweet.split(" ")
    tempTweet = []
    for word in wordList:
        if word.startswith("@") or word.startswith("#"):
            word = "<"+ word + ">"
        tempTweet.append(word)
    tempTweet = " ".join(tempTweet)
    tempTweetList.append(tempTweet)
    
abbTweets = tempTweetList
        
####### TreeTagger must ignore @ and # Twitter Tokens

           
                  

normalized_tagged_tweets = []


### Fill dict and lists with data

abbsDict = {}
counter = 0
posTagListPAISA = []
for entry in abbPosFile:
    counter += 1
    entry = entry.split("\t")
    abb = entry[0]
    fullform = entry[1]
    abbsDict[abb] = fullform
    
    posTags = entry[3].split(" | ")
    for posT in posTags:
        if posT not in posTagListPAISA:
            posTagListPAISA.append(posT)
            
    posTags = entry[5].split(" | ")
    for posT in posTags:
        posTs = posT.split(" #X# ")
        for pT in posTs:
            if pT not in posTagListPAISA:
                posTagListPAISA.append(pT)  
                
                
abbWithoutPosDict = {entry:abbDict[entry] for entry in abbDict if entry not in abbsDict}
                 
### Fill dict and lists with data

# Replaces rare/distinct abbs where no disambiguation is needed.
boundaries = ["!","?",",",";",":","."]
tempTweetList = []
for tweet in abbTweets:
    
    #tweet = "test di 1700 m.s.l.m. completamente biologic by J.R.R. Tolkien" # Example
    ## Replace abbs bounded to certain conditions
    for condition in abbsCondDict:
        result = re.search(condition, tweet)
        if result:
            abb = result.group(1)
            tweet = tweet.replace(abb,abbsCondDict[condition])
            countDistinctAbb += 1
            #print tweet
    ## Replace abbs bounded to certain conditions
    for abb in abbWithoutPosDict:

        spacedAbb = " " + abb + " "
        #tweet = "Test dal twedalet dal.. dal"
        #tweet = "Test dal tweet"
        if abb in tweet:
            abbMatch = re.finditer(r"(\b%s\b)" % abb, tweet) #abbMatch = re.findall(r"(\b(%s)\b)" % abb, tweet)
            shiftCounter = 0
            for ele in abbMatch:
                #print "%s: %s" % (ele.start(), ele.group(1))
                lenAbb = len(abb)
                isPunct = False
                try:
                    distance = ele.start()-2
                    if distance < 0 or tweet[distance] in ["?","!","."]:
                        isPunct = True
                except IndexError:
                    isPunct = True 
                fullform = abbWithoutPosDict[abb]
                if isPunct:
                    fullform = fullform[0].upper() + fullform[1:]                
                tweet = tweet[:ele.start()+shiftCounter] + fullform + tweet[lenAbb+ele.start()+shiftCounter:]
                shiftCounter += len(abbWithoutPosDict[abb])-lenAbb
                countDistinctAbb += 1
                countMatch += 1
                #print abb + " replaced: " + abbWithoutPosDict[abb] + "\t" + tweet
        abbLower = abb.lower()   
        tweetLower = tweet.lower()
        if abbLower in tweetLower:
            abbMatch = re.finditer(r"(\b%s\b)" % abbLower, tweetLower) #abbMatch = re.findall(r"(\b(%s)\b)" % abb, tweet)
            shiftCounter = 0
            for ele in abbMatch:
                #print "%s: %s" % (ele.start(), ele.group(1))
                lenAbb = len(abbLower)
                isPunct = False
                try:
                    distance = ele.start()-2
                    if distance < 0 or tweet[distance] in ["?","!","."]:
                        isPunct = True
                except IndexError:
                    isPunct = True 
                fullform = abbWithoutPosDict[abb]
                if isPunct:
                    fullform = fullform[0].upper() + fullform[1:]
                tweet = tweet[:ele.start()+shiftCounter] + fullform + tweet[lenAbb+ele.start()+shiftCounter:]
                shiftCounter += len(abbWithoutPosDict[abb])-lenAbb
                countDistinctAbb += 1
                countMatch += 1            
        # Without punct marks in abbs too much failures
#         abbNonPunct = abb.replace(".","").replace("\\","")
#         if abbNonPunct in tweet:
#             abbMatch = re.finditer(r"(\b%s\b)" % abbNonPunct, tweet) #abbMatch = re.findall(r"(\b(%s)\b)" % abb, tweet)
#             shiftCounter = 0
#             for ele in abbMatch:
#                 #print "%s: %s" % (ele.start(), ele.group(1))
#                 lenAbb = len(abbNonPunct)
#                 tweet = tweet[:ele.start()+shiftCounter] + abbWithoutPosDict[abb] + tweet[lenAbb+ele.start()+shiftCounter:]
#                 shiftCounter += len(abbWithoutPosDict[abb])-lenAbb
#                 countDistinctAbb += 1
#                 print abb + " replaced. with : " +abbWithoutPosDict[abb]+"    " + tweet
                   
            
            
    tempTweetList.append(tweet)
               
abbTweets = tempTweetList 

## Replaces rare/distinct abbs where no disambiguation is needed.
                

    
                
                

## Print Pos Tag List to map Pos Tags
# for posTag in posTagListTT:
#     print posTag
   
# print "#########"    
# for posTag in posTagListPAISA:
#     print posTag
## Print Pos Tag List to map Pos Tags
    
    


class AbbPos:
    abb = ""
    fullform = ""
    abbPOS = ""
    fullformPOS = ""
    context = ""
    contextPOS = ""
  
  
    
abbPosList = []

for line in abbPosFile:
    line = line.split("\t")
    abbPos = AbbPos()
    abbPos.abb = line[0]
    abbPos.fullform = line[1]
    abbPos.abbPOS = line[2]
    abbPos.fullformPOS = line[3]
    abbPos.context = line[4]
    abbPos.contextPOS = line[5]
    abbPosList.append(abbPos)


def getAbbPos(abb):
    for abbPos in abbPosList:
        if abbPos.abb == abb:
            return abbPos  
    return 0

'''
Maps TreeTagger-POS-Tags to PAISA-POS-Tags
'''
def mapPosTag(postagTT):
    if postagTT == "ADJ":
        return "A"
    elif postagTT == "ADV":
        return "B"
    elif postagTT.startswith("CON"):
        return "C"       
    elif postagTT.startswith("DET"):
        return "R"    # ["R","T","D"]  
    elif postagTT == "NOM":
        return "S"
    elif postagTT == "SENT":
        return "F"
    elif postagTT.startswith("PRE"):
        return "E"   
    elif postagTT.startswith("VER"):
        return "V"
    elif postagTT.startswith("PRO"):
        return "P"
    elif postagTT == "NUM":
        return "N"  
    else:
        return postagTT  
    
    
# countMatch = 0
# for tweet in abbTweets:
#     for entry in abbsDict:
#         if " " + entry + " " in tweet or " " + entry + " " in tweet or " " + entry + "!" in tweet :
#             countMatch += 1
#             print "Abb: " +  entry
#             print tweet

  
'''
Tags the input (tweet) list with TreeTagger
'''
def tagWithTT(abbTweets,processingRound):
    seperateString = ""
    
    if processingRound == 1:
        seperateString = "##########"
    else:
        seperateString = "^^^^^^^^"
    
    tagged_tweets = []
    
    ################ Tag tweets with TreeTager
    ######## Write tweets to temp file for tt 
    tmpFile = open("tweet_tt_temp", "w")
    
    
    for tweet in abbTweets:
        tmpFile.write(tweet +" "+seperateString+"\n\n")
    
    tmpFile.close()     
    ######## Write tweets to temp file for tt 

          
    taggerOutput = subprocess.Popen(["tag-italian.bat","tweet_tt_temp"],stdout=subprocess.PIPE)
    
    allTaggedTweets = taggerOutput.stdout.read()
    
    ################ Tag tweets with TreeTager

    ######## Prepare tagged Output
    taggedTokenList = allTaggedTweets.split("\n")
    
    taggedTweet = []
    
    for taggedToken in taggedTokenList:
        tokenInfo = taggedToken.split("\t")
        taggedTweet.append(tokenInfo)
        if seperateString in tokenInfo[0]:      
            tagged_tweets.append(taggedTweet)
            taggedTweet = []  
    ######## Prepare tagged Output
    
    
    return tagged_tweets




tweetNumber = 0

posTagListTT = []

tagged_tweets = tagWithTT(abbTweets,1)

countTweet = 0
countFlagSet = 0
countReplaceAbb = 0
markChangesList = [0] * len(tagged_tweets)
isPunct = False
isPrevPunct = False
isFirstToken = False
for taggedTweet in tagged_tweets: # run through all TreeTagger tagged tweets
    isNextPunct = ""
    countTokenInfo = 0
    normalized_taggedTweet = []
    isFirstToken = True
    isPopPunct = False

    for tokenInfo in taggedTweet:
        isPopPunct = False
        isNextPunct = ""
        try:
            tokenInfo[1]
        except:
            countTokenInfo += 1
            normalized_taggedTweet.append(tokenInfo)
            continue
        if tokenInfo[0] in ["!",".","?"]:
            isPunct = True
            isPrevPunct = False
        else:
            if isPunct:
                isPunct = False
                isPrevPunct = True
            else:
                isPrevPunct = False
                
        ## Is Punct following the current token
        nextIndex = countTokenInfo+1 if countTokenInfo else 1
        if nextIndex < len(taggedTweet) and taggedTweet[nextIndex][0] in ["!","?","."]:
            isNextPunct = taggedTweet[nextIndex][0]
        ## Is Punct following the current token
       

        if tokenInfo[1] not in posTagListTT: posTagListTT.append(tokenInfo[1])
        #print tokenInfo[0] + "\t" + tokenInfo[1] + "\t" + tokenInfo[2] + " " + tokenInfo[3]
        if tokenInfo[0].lower() in abbsDict or (isNextPunct  and tokenInfo[0].lower()+isNextPunct in abbsDict):
                        
            isReplace = False
            abbPos = getAbbPos(tokenInfo[0].lower())
            if abbPos == 0:
                isPopPunct = True
                abbPos = getAbbPos(tokenInfo[0].lower()+isNextPunct)
            
            if tokenInfo[0] == "a" and tokenInfo[1] == "PRE":
                normalized_taggedTweet.append(tokenInfo)
                continue
            
            #### MATCH POS TAG CONTEXT
            isPosTagContextMatched = False
            prePosTag = ""
            ## Pass tokens ignored by TreeTagger
            try:
                prePosTag = taggedTweet[countTokenInfo-1][1]
            except:
                try:
                    if len(taggedTweet[countTokenInfo-1]) == 1:
                        prePosTag = taggedTweet[countTokenInfo-2][1]
                except:
                    prePosTag = "-"
            postPosTag = ""
            try:
                postPosTag = taggedTweet[countTokenInfo+1][1]
            except:
                try:
                    if len(taggedTweet[countTokenInfo+1][1]) == 1:
                        postPosTag = taggedTweet[countTokenInfo+2][1]
                except:
                    postPosTag = "-"    
            ## Pass tokens ignored by TreeTagger                
                        
            contextPos = mapPosTag(prePosTag) + " #X# " + mapPosTag(postPosTag)
            contextPosList = abbPos.contextPOS.split(" | ")
            for cP in contextPosList:
                if cP == contextPos:
                    isReplace = True
                    markChangesList[countTweet] = 1
                    countReplaceAbb += 1
                    #print tokenInfo[0] + " ##### " + abbsDict[tokenInfo[0]]
                    try:
                        words = abbsDict[tokenInfo[0].lower()].split(" ")
                    except:
                        words = abbsDict[tokenInfo[0].lower()+isNextPunct].split(" ")
                    if isPrevPunct or isFirstToken: # if previous token is sentence punctuation write first char of abb uppercase
                        tokenInfo[0] = words.pop(0).title()
                    else:
                        tokenInfo[0] = words.pop(0)
                    normalized_taggedTweet.append(tokenInfo)
                    for word in words:
                        normalized_taggedTweet.append([word,"-","-","-"])
                        #print word
                    #countReplaceAbb += len(words)
                    isPosTagContextMatched = True
                    if isPopPunct:
                        del taggedTweet[nextIndex]
                    break
                    

            #### MATCH POS TAG CONTEXT
            
            if not isPosTagContextMatched:
                #### MATCH CONTEXT
                context = mapPosTag(taggedTweet[countTokenInfo-1][0]) + " #X# " + mapPosTag(taggedTweet[countTokenInfo+1][0])
                contextList = abbPos.context.split(" | ")
                for cP in contextList:
                    if cP == context:
                        isReplace = True
                        markChangesList[countTweet] = 1
                        countReplaceAbb += 1
                        #print tokenInfo[0] + " ##### " + abbsDict[tokenInfo[0]]
                        try:
                            words = abbsDict[tokenInfo[0].lower()].split(" ")
                        except:
                            words = abbsDict[tokenInfo[0].lower()+isNextPunct].split(" ")
                        if isPrevPunct or isFirstToken: # if previous token is sentence punctuation write first char of abb uppercase
                            tokenInfo[0] = words.pop(0).title()
                        else:
                            tokenInfo[0] = words.pop(0)                         
                        normalized_taggedTweet.append(tokenInfo)
                        for word in words:
                            normalized_taggedTweet.append([word,"-","-","-"])
                        countTokenInfo += len(words)
                        if isPopPunct:
                            del taggedTweet[nextIndex]                        
                        break
                        
                #### MATCH CONTEXT
             
            #### Replace but set unsure flag 
            if not isReplace:
                countFlagSet += 1
                
                words = abbsDict[abbPos.abb].split(" ")

                if isPrevPunct or isFirstToken: # if previous token is sentence punctuation write first char of abb uppercase
                    tokenInfo[0] = words.pop(0).title()
                else:
                    tokenInfo[0] = words.pop(0)  
                tokenInfo.append(tokenInfo[1])                                   
                normalized_taggedTweet.append(tokenInfo)
                for word in words:
                    normalized_taggedTweet.append([word,"-","-","-","flag"])
                #print tokenInfo[0] + " " + str(countTweet) + " " + str(countTokenInfo)
                countFlagSet += len(words)
                if isPopPunct:
                    del taggedTweet[nextIndex]    
                       
            
            #### Replace but set unsure flag 
             
                        
            countMatch += 1
            #print "Abb: " +  tokenInfo[0]
            #print abbTweets[tweetNumber]
        else:
            
            normalized_taggedTweet.append(tokenInfo) # Comment line to show only abbs in compare mode
        isFirstToken = False
        countTokenInfo += 1
    countTweet += 1
    normalized_tagged_tweets.append(normalized_taggedTweet)
    #print "::::::::::::::::::"
    tweetNumber += 1
        




abbTweetsNormalized = []


for normalized_taggedTweet in normalized_tagged_tweets:
    line = ""
    for tokenInfo in normalized_taggedTweet:
        line += tokenInfo[0] + " "
    abbTweetsNormalized.append(line)
    

tagged_tweets_normalized = tagWithTT(abbTweetsNormalized,2)


countTweets = 0
countFlagFound = 0
countFlagWithPos = 0
countContextReplace = 0
countProbReplace = 0
for tagged_tweet_normalized in tagged_tweets_normalized:
    wordCount = 0
    for tokenInfo in tagged_tweet_normalized:
        isCorrect = False
        posTagFlag = ""
        try:
            posTagFlag = normalized_tagged_tweets[countTweets][wordCount][4] # Is Flag set?          
            countFlagFound += 1
        except:
            pass
        
        if posTagFlag:
            if normalized_tagged_tweets[countTweets][wordCount][1] == "-": # Do not check words inside an abb
                continue                              # tvtb ti voglio tanto bene, do not conside bn for bene
                 
            word = normalized_tagged_tweets[countTweets][wordCount][0]
            posTag = mapPosTag(posTagFlag)
            correctPosTagList = []
            for entry in abbsDict: # Get Abb by Fullform
                if abbsDict[entry] == word:
                    correctPosTagList = getAbbPos(entry).fullformPOS.split(" | ")
                    break
            #print correctPosTagList

            if posTag != 0:
                for cPT in correctPosTagList:
                    #print cPT + " " + posTag
                    if cPT == posTag:
                        countFlagWithPos += 1
                        #print tokenInfo[0] + " "   + str(countTweets) + " " + str(wordCount)
                        isCorrect = True
                        countContextReplace += 1
                        markChangesList[countTweets] = 1
                        #print "tag: " + tokenInfo[1]
                        #print "prob: " + tokenInfo[3]
                        
        
            if not isCorrect:
                #print "#########"
                #print "word: " + tokenInfo[0]
                #print "tag: " + tokenInfo[1]
                #print "prob: " + tokenInfo[3]
                
                
                ####### Extract Pos Tag Probability
                highestprob = 0.0
                if len(tokenInfo) == 1:
                    wordCount += 1
                    continue
                probValues = tokenInfo[3].split(" ")
                if len(probValues) < 12:
                    values = []
                    for probVal in probValues:
                        prob = 0.0
                        try:
                            prob = float(probVal)
                            values.append(prob)
                        except:
                            pass
                    highestprob = max(values)
                if highestprob < 0.85: # Replace fullform with low prob with its abb                   
                    for entry in abbsDict:
                        if tokenInfo[0] == abbsDict[entry]:
                            #print tokenInfo[0] + " " + entry
                            tokenInfo[0] = entry
                else:
                    markChangesList[countTweets] = 1
                    countProbReplace += 1
                    
                ####### Extract Pos Tag Probability
                #print "highest prob: " + str(highestprob)
                #print "#########"        


        
        
        wordCount += 1
    countTweets += 1



finalTweets = []
for tagged_tweet_normalized in tagged_tweets_normalized:
    line = ""
    for tokenInfo in tagged_tweet_normalized:
        if tokenInfo[0].startswith("<") and tokenInfo[0].endswith("\r"):
            line += tokenInfo[0].rstrip()[1:-1] + " "
        else:
            line += tokenInfo[0] + " "
    finalTweets.append(line)
    
tweetCounter = 0
for tweet in finalTweets:
    tweet = tweet.replace(" ########## ^^^^^^^^ ","")
    tweet = tweet.replace(" ' ","'") # Normalize ' (spaced by TreeTagger)
    tweet = tweet.replace(" . . "," ") # Normalize . (tokenized by TreeTagger)
    if fileWrite: 
        if isCompareMode:
            if isShowChangesOnly:
                if markChangesList[tweetCounter] == 1:                   
                    normed_abbTweets.write(abbTweetsUnchanged[tweetCounter] + "\n" + tweet + "\n\n")
            else:
                normed_abbTweets.write(abbTweetsUnchanged[tweetCounter] + "\n" + tweet + "\n\n")
        else:
            normed_abbTweets.write(tweet + "\n")  
    if debug: print tweet

    tweetCounter += 1

print "\nInput tweet count: " + str(len(abbTweets))    
print "Final tweet count: " + str(len(finalTweets))

print "\n" "Count flag set: " + str(countFlagSet)
print "Count flag found: " + str(countFlagFound)
print "Count flag with Pos found: " + str(countFlagWithPos)




result = "\nResults: '" + inputFileName + "'\n" + \
    "\nAbbreviations in Dict: " + str(len(abbsDict)) + \
    "\nTweet Count: " + str(len(abbTweets)) + \
    "\nAbbreviations found: " + str(countMatch) + \
    "\nSave context replacement: " + str(countReplaceAbb) + \
    "\nSame POS-Tag replacement: " + str(countContextReplace) + \
    "\nProbability replacement: " + str(countProbReplace) + \
    "\nReplaced rare/distinct abbs where no disambiguation is needed: " + str(countDistinctAbb) + \
    "\nTotal Abbreviation replacement: " + str(countProbReplace+countContextReplace+countReplaceAbb+countDistinctAbb) + "/" + str(countMatch) + \
    "\n\nFrom " + str(countMatch) + " Abbreviations found in " + str(len(abbTweets)) + " tweets " \
    + str(countProbReplace+countContextReplace+countReplaceAbb+countDistinctAbb) + " Abbreviations were replaced."
    
print result 
  
    
if isCreateSummary:
    normed_abbTweets_Results.write(result)
    
    



'''

Preprocessing: map posTags

Funktionsweise:



 - tweets temporär in Datei schreiben für TreeTager Annotation
 - Annotierte Tweets einzeln (zeilenweise) ausgeben:
 
   Für jedes Wort im Tweet wird überprüft ob das Wort im Abkürzungskorpus vorkommt
       - falls die Abkürzung vorkommt werden die entsprechenden Abkürzungsinformationen geladen
           - es wird der Kontext der Abkürzung im Tweet mit dem in der Liste hinterlegten Kontext verglichen
           - es wird der POS-Tag Kontext der Abkürzung im Tweet mit dem in der Liste hinterlegten POS-Tag Kontext verglichen
                - falls einer der beiden Kontexte übereinstimmt wird die Abb mit der entsprechenden Vollform ersetzt
                
                - falls der Kontext nicht übereinstimmt wird die Abb tdem mit dem Vollform erstetzt 
                  aber als "unsicher" markiert und der aktuelle POS-Tag der Abkürzung im Tweet gespeichert
  
    
 - "normalisierte" tweets temporär in Datei schreiben für TreeTager Annotation   
 - Wieder "normalisierte" Annotierte Tweets einzeln (zeilenweise) ausgeben:
 
     Hier werden keine Abkürzungen mehr gefunden, da bereits alle ersetzt wurden
     
     Bei jeder Ersetzung die mit "unsicher" markiert wurde wird der POS-Tag 
     der ersetzten Abkürzung ausgelesen und mit dem in der Abkürzungsliste hinterlegten Postag der Vollform verglichen
     
     Falls die POS-Tags übereinstimmen wird die Wahrscheinlichkeit mit der der Pos-Tag korrekt ist betrachtet
     falls die zuversichtlichkeit über 90 % liegt bleibt die ersetzung bestehen
                
                











    Pos - tag - mapping




NOM = S
ADJ = A
PRE = E
SENT = F
CON = C
ADV = B
NUM = N
VER* = V
DET* = R
DET* = T
DET* = D
PRO* = P
I
EOS
X






PRE:det = PREP
DET:indef = ART
DET:def = ART

VER:cpre = VERB
VER:pres = VERB
VER:infi = VERB
VER:pper = VERB
VER:impe = VERB
VER:futu = VERB
VER:cimp = VERB
VER:geru = VERB
VER:ppre = VERB
VER:impf = VERB
VER:remo = VERB
VER:cond = VERB

PRO:poss = PRON
PRO:demo = PRON
PRO:rela = PRON
PRO:pers = PRON
PRO:indef = PRON
PRO:refl = PRON
PRO:inter = PRON
NPR
ABR
INT
ORD
FW
SYM
PRO
LS
    = DATE
    = QUALIF


















    
NOM
ADJ
SENT
PRE:det
PON
PRE
NPR
ABR
INT
ADV
VER:pres
VER:infi
PRO:rela
VER:cpre
DET:def
PRO:refl
VER:pper
CON
VER:impe
NUM
SYM
PRO:indef
VER:impf
VER:remo
DET:indef
PRO:pers
VER:futu
VER:cimp
VER:geru
PRO:poss
PRO:demo
VER:cond
PRO:inter
ORD
FW
VER:ppre
PRO
LS
#########
S
A
E
F
C
V
R
B
P
D
N
I
T
EOS
X
'''