import re, collections,string

def words(text): return re.findall('[a-z]+', text.lower()) 

def train(features):
    model = collections.defaultdict(lambda: 1)
    for f in features:
        model[f] += 1
    return model

NWORDS = train(words(file('resources/hermitd(wiki_user)_Italian50k_.txt').read()))

alphabet = 'abcdefghijklmnopqrstuvwxyz'

def edits1(word):
    splits     = [(word[:i], word[i:]) for i in range(len(word) + 1)]
    deletes    = [a + b[1:] for a, b in splits if b]
    transposes = [a + b[1] + b[0] + b[2:] for a, b in splits if len(b)>1]
    replaces   = [a + c + b[1:] for a, b in splits for c in alphabet if b]
    inserts    = [a + c + b     for a, b in splits for c in alphabet]
    return set(deletes + transposes + replaces + inserts)

def known_edits2(word):
    return set(e2 for e1 in edits1(word) for e2 in edits1(e1) if e2 in NWORDS)

def known(words): return set(w for w in words if w in NWORDS)

def correct(word):
    candidates = known([word]) or known(edits1(word)) or known_edits2(word) or [word]
    return max(candidates, key=NWORDS.get)



vocab_big = open("resources/combinedVocabMin3.vocab").read().split("\n")

vocabDict = {}
for line in vocab_big:
    line = line.split("\t")
    word = line[0].strip()
    count = line[0].strip()
    vocabDict[word] = count


#tweets = open("twita_tweets201202_01.txt").read().split("\n")
tweets = open("twita_tweets201202_01.txt.cleantweets").read().split("\n")

tweetCount = 0
for tweet in tweets:
    cleanedTweet = []
    #tweet = tweet.split("\t\t")[1]
    #print tweet
    tweet = tweet.split(" ")
    for word in tweet:
        if len(word) < 5:
            cleanedTweet.append(word)
            continue
        isPunct = False
        for punct in string.punctuation:
            if punct in word:
                isPunct = True
                break

        if isPunct or word[0].isupper():
            cleanedTweet.append(word)
            continue        
        elif word in vocabDict:
            cleanedTweet.append(word)
        else:
            corrected = correct(word)
            if corrected != word:
                print "word: " + word + " corrected: " + corrected
            else:
                pass#print word + " " + corrected
    tweetCount += 1
    #print tweetCount
        